# cargo build

## NAME

cargo-build - Compile the current package

## SYNOPSIS

`cargo build [OPTIONS]`

## DESCRIPTION

Compile local packages and all of their dependencies.

## OPTIONS

### Package Selection

By default, when no package selection options are given, the packages selected depend on the current working directory. In the root of a virtual workspace, all workspace members are selected (`--all` is implied). Otherwise, only the package in the current directory will be selected. The default packages may be overridden with the `workspace.default-members` key in the root `Cargo.toml` manifest.

-p SPEC…​
--package SPEC…​

  Build only the specified packages. See cargo-pkgid(1) for the SPEC format. This flag may be specified multiple times.

--all

  Build all members in the workspace.

--exclude SPEC…​

  Exclude the specified packages. Must be used in conjunction with the `--all` flag. This flag may be specified multiple times.

### Target Selection

When no target selection options are given, `cargo build` will build all binary and library targets of the selected packages. Binaries are skipped if they have `required-features` that are missing.

Passing target selection flags will build only the specified targets.

--lib

  Build the package’s library.

--bin NAME…​

  Build the specified binary. This flag may be specified multiple times.

--bins

  Build all binary targets.

--example NAME…​

  Build the specified example. This flag may be specified multiple times.

--examples

  Build all example targets.

--test NAME…​

  Build the specified integration test. This flag may be specified multiple times.

--tests

  Build all tests. This includes both unit tests for libraries and binaries and integration tests. Targets may be disabled by setting `test = false` in the manifest settings for the target. Targets (such as examples) may be explicitly included by setting `test = true` in the target settings.

--bench NAME…​

  Build the specified benchmark. This flag may be specified multiple times.

--benches

  Build all benchmarks. This includes both unit benchmarks for libraries and binaries and bench targets. Targets may be disabled by setting `bench = false` in the manifest settings for the target. Targets (such as examples) may be explicitly included by setting `bench = true` in the target settings.

--all-targets

  Build all targets.

### Feature Selection

When no feature options are given, the `default` feature is activated for every selected package.

--features FEATURES

  Space or comma separated list of features to activate. These features only apply to the current directory’s package. Features of direct dependencies may be enabled with `<dep-name>/<feature-name>` syntax.

--all-features

  Activate all available features of all selected packages.

--no-default-features

  Do not activate the `default` feature of the current directory’s package.

### Compilation Options

--target TRIPLE

  Build for the given architecture. The default is the host architecture.

  The general format of the triple is `<arch><sub>-<vendor>-<sys>-<abi>` where:

  - `arch` = The base CPU architecture, for example `x86_64`, `i686`, `arm`, `thumb`, `mips`, etc.

  - `sub` = The CPU sub-architecture, for example `arm` has `v7`, `v7s`, `v5te`, etc.

  - `vendor` = The vendor, for example `unknown`, `apple`, `pc`, `linux`, etc.

  - `sys` = The system name, for example `linux`, `windows`, etc. `none` is typically used for bare-metal without an OS.

  - `abi` = The ABI, for example `gnu`, `android`, `eabi`, etc.

  Some parameters may be omitted. Run `rustc --print target-list` for a list of supported targets.

  This may also be specified with the `build.target` config value.

--release

  Build artifacts in release mode, with optimizations. See the PROFILES section for details on how this affects profile selection.

### Output Options

--target-dir DIRECTORY

  Directory for all generated artifacts and intermediate files. May also be specified with the `CARGO_TARGET_DIR` environment variable, or the `build.target-dir` config value. Defaults to `target` in the root of the workspace.

--out-dir DIRECTORY

  Copy final artifacts to this directory.

  This option is unstable and available only on the nightly channel and requires the `-Z unstable-options` flag to enable.

### Display Options

-v
--verbose

  Use verbose output. May be specified twice for "very verbose" output which includes extra output such as dependency warnings and build script output. May also be specified with the `term.verbose` config value.

-q
--quiet

  No output printed to stdout.

--color WHEN

  Control when colored output is used. Valid values:

  - `auto` (default): Automatically detect if color support is available on the terminal.

  - `always`: Always display colors.

  - `never`: Never display colors.

  May also be specified with the `term.color` config value.

--message-format FMT

  The output format for diagnostic messages. Valid values:

  - `human` (default): Display in a human-readable text format.

  - `json`: Emit JSON messages to stdout.

  - `short`: Emit shorter, human-readable text messages.

--build-plan

  Outputs a series of JSON messages to stdout that indicate the commands to run the build.

  This option is unstable and available only on the nightly channel and requires the `-Z unstable-options` flag to enable.

### Manifest Options

--manifest-path PATH

  Path to the `Cargo.toml` file. By default, Cargo searches in the current directory or any parent directory for the `Cargo.toml` file.

--frozen
--locked

  Either of these flags requires that the `Cargo.lock` file is up-to-date. If the lock file is missing, or it needs to be updated, Cargo will exit with an error. The `--frozen` flag also prevents Cargo from attempting to access the network to determine if it is out-of-date.

  These may be used in environments where you want to assert that the `Cargo.lock` file is up-to-date (such as a CI build) or want to avoid network access.

### Common Options

-h
--help

  Prints help information.

-Z FLAG…​

  Unstable (nightly-only) flags to Cargo. Run `cargo -Z help` for details.

### Miscellaneous Options

-j N
--jobs N

  Number of parallel jobs to run. May also be specified with the `build.jobs` config value. Defaults to the number of CPUs.

## PROFILES

Profiles may be used to configure compiler options such as optimization levels and debug settings. See the reference for more details.

Profile selection depends on the target and crate being built. By default the `dev` or `test` profiles are used. If the `--release` flag is given, then the `release` or `bench` profiles are used.

Target | Default Profile | `--release` Profile
--- | --- | ---
lib, bin, example | `dev` | `release`
test, bench | `test` | `bench`

Dependencies use the `dev`/`release` profiles.

## ENVIRONMENT

See the reference for details on environment variables that Cargo reads.

## Exit Status

0

  Cargo succeeded.

101

  Cargo failed to complete.

## EXAMPLES

1. Build the local package and all of its dependencies:

       cargo build

2. Build with optimizations:

       cargo build --release

## SEE ALSO

cargo(1), cargo-rustc(1)